<!--THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
#  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE LICENSE AGREEMENT 
#  ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK) THAT CONTAINS THIS WORK.
#  PURSUANT TO THE SDK LICENSE AGREEMENT, NOVELL HEREBY GRANTS TO DEVELOPER 
#  A ROYALTY-FREE, NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S SAMPLE CODE IN 
#  ITS PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION RIGHTS TO MARKET,
#  DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT OF DEVELOPER'S PRODUCTS.
#  NOVELL SHALL HAVE NO OBLIGATIONS TO DEVELOPER OR DEVELOPER'S CUSTOMERS WITH 
#  RESPECT TO THIS CODE. 
# 
# Name		  	: attributes.php
# Description	: This file will set and get the specified attribute values.
-->


<?php

$dir = new UCS('UCX:NWDir') or die ("Unable to create the NWDir object\n<br>");

$UserName = "username";
$Password = "password";
$User ="DummyUser";

$dir->login($UserName, $Password) or die ("Login failed. Please check your UserName and Password\n<br>");

$entries = $dir->entries();
$newUser = $entries->add($User, "User") or die ("Unable to add the user\n<br>");

SetAttributes($newUser);

Update($newUser);

Display($dir, $User);

$dir->logout();


function SetAttributes($newUser)
{
	NW_CASE_IGNORE_STRING($newUser);
	NW_BOOLEAN($newUser);
	NW_COUNTER($newUser);
	NW_DISTINGUISHED_NAME($newUser);
	NW_EMAIL_ADDRESS($newUser);
	NW_FAX_NUMBER($newUser);
	NW_HOLD($newUser);
	NW_INTEGER($newUser);
	NW_INTERVAL($newUser);
	NW_NET_ADDRESS($newUser);
	NW_NUMERIC_STRING($newUser);
	NW_OCTET($newUser);
	NW_PATH($newUser);
	NW_PRINTABLE_STR($newUser);
	NW_TELNUMBER($newUser);
}


function Update($entry)
{
	$entry->setFieldValue("Surname", "Leo") or die ("Unable to SetFieldValue SurName\n<br>");

	if(!$entry->update()) {
		die ("Unable to add teh specified user. Please check the arguments\n<br>");
	} else {
		// Set password for the user after adding the user into the context
		$UserPassword = "NewPassword";
		if(!$entry->SetPassword($UserPassword)) {
			die ("User added, but unable to set new passoword for it\n<br>");
		}
	}
}


function NW_CASE_IGNORE_STRING($entry)
{
	$entry->setFieldValue("employeeType","developer") or die ("Unable to SetFieldValue employeeType\n<br>");
	$entry->setFieldValue("Given Name","jDoe") or die ("Unable to SetFieldValue Initials\n<br>");
	$entry->SetFieldValue("Initials","RMS") or die ("Unable to SetFieldValue Initials\n<br>");
	$entry->setFieldValue("Internet EMail Address","doe@acme.com") or die ("Unable to SetFieldValue Email address\n<br>");
	$entry->SetFieldValue("preferredLanguage","english") or die ("Unable to SetFieldValue preferredLanguage\n<br>");
	$entry->SetFieldValue("roomNumber","1234") or die ("Unable to SetFieldValue roomNumber\n<br>");
}


function NW_BOOLEAN($entry)
{
	$entry->SetFieldValue('isManager', 1) or die ("Unable to SetFieldValue userPassword\n<br>");
}


function NW_COUNTER($entry)
{
	$entry->SetFieldValue("Login Grace Remaining",234) or die ("Unable to SetFieldValue Login Grace Remaining\n<br>");
}


function NW_DISTINGUISHED_NAME($entry)
{
	$entry->SetFieldValue("Group Membership", "NDS:\\\\blr-tree\\Org") or die ("Unable to SetFieldValue Group Membership\n<br>");
}


function NW_EMAIL_ADDRESS($entry)
{
	$emailaddress=new UCS('UCX:NWDIR.NWNETADDRESS') or die ('Unable to create the NWAddress object\n<br>');
	$emailaddress->{"Type"}=0;
	$emailaddress->{"Address"}="developer@acme.com";
	$entry->SetFieldValue("EMail Address",$emailaddress) or die ("Unable to SetFieldValue EMail Address\n<br>");
}


function NW_FAX_NUMBER($entry)
{
	$entry->SetFieldValue('Facsimile Telephone Number',"15246574") or die ("Unable to SetFieldValue Facsimile Telephone Number\n<br>");
}


function NW_HOLD($entry)
{
	$hold=new UCS('UCX:NWDIR.NWHOLD') or die ("Unable to create the NWHOLD object\n<br>");
	$hold->{'ObjectName'}="reporter";
	$hold->{'Amount'}=2000;
	$entry->SetFieldValue('Server Holds',$hold) or die ("Unable to SetFieldValue Server Holds\n<br>");
}


function NW_INTEGER($entry)
{
	$entry->SetFieldValue("Minimum Account Balance",1000) or die ("Unable to SetFieldValue Minimum Account Balance\n<br>");
}


function NW_INTERVAL($entry)
{
	$entry->SetFieldValue('Password Expiration Interval',3456000) or die ("Unable to SetFieldValue  Password Expiration Interval\n<br>");
}


function NW_NET_ADDRESS($entry)
{
	$netaddress=new UCS('UCX:NWDIR.NWNETADDRESS') or die ("Unable to create the NWAddress object\n<br>");
	$netaddress->{"Type"}=0;
	$netaddress->{"Address"}="010144DC111222333444";
	$entry->SetFieldValue("Login Intruder Address",$netaddress) or die ("Unable to SetFieldValue Login Intruder Address	$netaddress=new UCS('UCX:NWDIR.NWNETADDRESS') or die ('Unable to create the NWAddress object\n<br>");
}


function NW_NUMERIC_STRING($entry)
{
	$entry->SetFieldValue('internationaliSDNNumber','9008057318563456') or die ("Unable to SetFieldValue internationaliSDNNumber\n<br>");
}


function NW_OBJECT_ACL($entry)
{
	$oacl=new UCS('UCX:NWDIR.NWACL') or die ("Unable to create the NWACL object\n<br>");
	$oacl->{'Attribute'} = "Given Name";
	$oacl->{'Subject'} = "[Public]";
	$oacl->{'Privileges'} = 2;
	$entry->SetFieldValue('ACL',$oacl) or die ("Unable to SetFieldValue ACL Value\n<br>");
}


function NW_OCTET($entry)
{
	//  Needs to unpack it properly while getting the  value.
	$OctetValue=pack("C*", 0x5B, 0x5B,0x5C);
	$entry->SetFieldValue('userCertificate',$OctetValue) or die ("Unable to SetFieldValue  userPassword\n<br>");
}


function NW_PATH($entry)
{
	$nwpath=new UCS('UCX:NWDIR.NWPATH') or die ("Unable to create the NWPath object\n<br>");
	$nwpath->{'Type'} = 0;
	$nwpath->{'Volume'} = "BLR-MURUGAN-NAKOMA_SYS";
	$nwpath->{'Path'} = "/NSN/UTIL";
	$entry->SetFieldValue('Home Directory',$nwpath) or die ("Unable to SetFieldValue Home Directory\n<br>");
}


function NW_PRINTABLE_STR($entry)
{
	$entry->SetFieldValue('destinationIndicator','1234-xxx-1224') or die ("Unable to SetFieldValue destinationIndicator\n<br>");
}


function NW_TELNUMBER($entry)
{
	$entry->SetFieldValue('homePhone',"5246574") or die ("Unable to SetFieldValue  homePhone\n<br>");
}


function Display($Object,$User)
{
	$UserName=$User;

	// Change the Tree name 
	$entry=$Object->FindEntry("NDS:\\\\blr-tree\\Org\\"."$UserName");
	if(!$entry)
		return;

	$employeeType=$entry->getFieldValue("employeeType") or die ("Unable to getFieldValue employeeType\n<br>");
	$GivenName=$entry->getFieldValue("Given Name") or die ("Unable to getFieldValue Initials\n<br>");
	$Initials=$entry->getFieldValue("Initials") or die ("Unable to getFieldValue Initials\n<br>");
	$EMail=$entry->getFieldValue("Internet EMail Address") or die ("Unable to getFieldValue Email address\n<br>");
	$preferredLanguage=$entry->getFieldValue("preferredLanguage") or die ("Unable to getFieldValue preferredLanguage\n<br>");
    $roomNumber=$entry->getFieldValue("roomNumber") or die ("Unable to getFieldValue roomNumber\n<br>");
	$isManager=$entry->getFieldValue('isManager') or die ("Unable to getFieldValue  userPassword\n<br>");
	$LoginGrace=$entry->getFieldValue("Login Grace Remaining") or die ("Unable to getFieldValue Login Grace Remaining\n<br>");
	$groupmember=$entry->getFieldValue("Group Membership") or die ("Unable to getFieldValue Group Membership\n<br>");
    $Facsimile=$entry->getFieldValue('Facsimile Telephone Number') or die ("Unable to getFieldValue  Facsimile Telephone Number\n<br>");
	$holds=$entry->getFieldValue('Server Holds') or die ("Unable to getFieldValue Server Holds\n<br>");
    $balance=$entry->getFieldValue("Minimum Account Balance") or die ("Unable to getFieldValue Minimum Account Balance\n<br>");
    $interval=$entry->getFieldValue('Password Expiration Interval') or die ("Unable to getFieldValue  Password Expiration Interval\n<br>");
	$netaddress=$entry->getFieldValue("Login Intruder Address") or die ("Unable to getFieldValue Login Intruder Address\n<br>");
    $sdn=$entry->getFieldValue('internationaliSDNNumber') or die ("Unable to getFieldValue internationaliSDNNumber\n<br>");
	$nwpath=$entry->getFieldValue('Home Directory') or die ("Unable to getFieldValue Home Directory\n<br>");
    $dest=$entry->getFieldValue('destinationIndicator') or die ("Unable to getFieldValue destinationIndicator\n<br>");
    $homePhone=$entry->getFieldValue('homePhone') or die ("Unable to getFieldValue  homePhone\n<br>");
	$usercertificate=$entry->getFieldValue('userCertificate') or die ("Unable to getFieldValue  userCertificate\n<br>");
	$mailid=$entry->getFieldValue("EMail Address") or die ("Unable to getFieldValue Email Address\n<br>");
?>

<html>
	<head>
		<title>User Attributes</title>
	</head>

	<body bgcolor="#009999">
	<div align="center">
	<center>
		<h1>User Attributes</h1>
		<table  bgcolor=#999900 border><TD>
		<tr bgcolor= #999900><th>Synatx Type</th><B><th>Attribute Name</th><th>Value</th></tr>
		<td bgcolor= "wheat" >
				<?php echo "Name of the User Object"?>
			</td>
			<td bgcolor= "wheat" >
				<?php echo "User Object Name"?>
			</td>
			<td  bgcolor="wheat">
				<?php echo $UserName?>
			</td>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "CASE_IGNORE_STRING" ?>
			</td>
			<td bgcolor= "wheat" >
				<?php echo "EmployeeType"?>
			</td>
			<td  bgcolor="wheat">
				<?php echo $employeeType?>
			</td>
		</tr>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "CASE_IGNORE_STRING" ?>
			</td>

			<td bgcolor= "wheat">
				<?php echo "Given Name" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $GivenName ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "CASE_IGNORE_STRING" ?>
			</td>

			<td bgcolor= "wheat">
				<?php echo "Initials" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $Initials ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "CASE_IGNORE_STRING" ?>
			</td>

			<td bgcolor= "wheat">
				<?php echo "Internet EMail Address" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $EMail ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "BOOLEAN" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "isManager" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $isManager ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "COUNTER" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Login Grace Remaining" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $LoginGrace ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "FAX_NUMBER" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Facsimile Telephone Number" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $Facsimile ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "INTEGER" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Minimum Account Balance" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $balance ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "INTERVAL" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Password Expiration Interval" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $interval?>
			</td>
		</tr>
		<tr>
		<td bgcolor= "wheat">
			<?php echo "NUMERIC_STRING	" ?>
		</td>
		<td bgcolor= "wheat">
			<?php echo "internationaliSDNNumber	" ?>
		</td>
		<td bgcolor="wheat">
				<?php echo $sdn ?>
		</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "PRINTABLE_STR" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "destinationIndicator	" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $dest ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "TELNUMBER" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "homePhone" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $homePhone ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "PATH" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Home Directory Type " ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $nwpath->{'Type'} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "PATH" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Home Directory Volume " ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $nwpath->{'Volume'} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "PATH" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Home Directory Path " ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $nwpath->{'Path'} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "NET_ADDRESS" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Login Intruder Address Type" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $netaddress->{"Type"} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "NET_ADDRESS" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Login Intruder Address" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $netaddress->{"Address"} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "HOLDS" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo $holds->{'ObjectName'}."   Holds  " ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $holds->{'Amount'} ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "DIST_NAME" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Group Membership" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $groupmember; ?>
			</td>
		</tr>
		<tr>
			<td bgcolor= "wheat">
				<?php echo "EMAIL_ADDRESS" ?>
			</td>
			<td bgcolor= "wheat">
				<?php echo "Email Address" ?>
			</td>
			<td bgcolor="wheat">
				<?php echo $mailid->{'Address'} ?>
			</td>
		</tr>

</div>
</center>

</body>
</html>

<?php
}
?>
